﻿Class Window1
    'Se declara una variable de tipo DataSet
    Private ProveedoresDatos As New dbInventarioDataSet
    'Se declara una variable TableAdapter para consumir los datos de la base de datos
    Private taProv As New dbInventarioDataSetTableAdapters.tbProveedoresTableAdapter
    'taAdmin proporciona la funcionalidad para guardar datos en tablas de datos
    Private taAdmin As New dbInventarioDataSetTableAdapters.TableAdapterManager
    'vista Representa una vista para agrupar, ordenar, filtrar y navegar por una recolección de datos
    Private vista As CollectionView
    Private db As New DatosDataContext
    Dim tipoCarga As Integer = 0
    Sub CargarCmbPaises()
        'Dim datos As Object
        'If tipoCarga = 0 Then
        '    datos = From x In db.tbPaises, y In db.tbProveedores _
        '                Where x.IdPais = y.IdPais And y.IdProveedor = TextBox1.Text _
        '                Select x.IdPais, x.NombrePais
        'Else
        '    datos = From x In db.tbPaises _
        '    Select x.IdPais, x.NombrePais
        'End If


        Dim datosPais = From x In db.tbPaises _
                          Select x.IdPais, x.NombrePais

        Me.cmbPaises.ItemsSource = datosPais
        ' Indicamos el valor a mostrar
        Me.cmbPaises.DisplayMemberPath = "NombrePais"
        ' Indicamos el codigo asociado al valor mostrado
        Me.cmbPaises.SelectedValuePath = "IdPais"
        'Me.cmbPaises.SelectedValue = "IdPais"
        Me.cmbPaises.SelectedIndex = 0
    End Sub
    Private Sub Window1_Loaded(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles Me.Loaded
        'Rellena taProv con los datos tbProveedores
        Me.taProv.Fill(Me.ProveedoresDatos.tbProveedores)
        'Establece el TableAdapter como origen de datos de taAdmin
        Me.taAdmin.tbProveedoresTableAdapter = taProv
        'El contexto de datos se establece con la tabla tbProveedores
        Me.DataContext = Me.ProveedoresDatos.tbProveedores
        'El origen de la vista de datos es la coleccion de datos de tbProveedores
        Me.vista = CollectionViewSource.GetDefaultView(Me.ProveedoresDatos.tbProveedores)
        CargarCmbPaises()
    End Sub

    Private Sub btnPrimero_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnPrimero.Click
        'Ir al primero registro de la vista
        Me.vista.MoveCurrentToFirst()
    End Sub

    Private Sub btnAnterior_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnAnterior.Click
        If Me.vista.CurrentPosition > 0 Then
            'Ir al registro anterior de la vista si ésta no está vacía
            Me.vista.MoveCurrentToPrevious()
        End If
    End Sub

    Private Sub btnSiguiente_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnSiguiente.Click
        If Me.vista.CurrentPosition < Me.vista.Count - 1 Then
            'Ir al registro siguiente de la vista si ésta no está vacía
            Me.vista.MoveCurrentToNext()
        End If
    End Sub

    Private Sub btnUltimo_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnUltimo.Click
        'Ir al último registro de la vista
        Me.vista.MoveCurrentToLast()
    End Sub

    Private Sub btnEliminar_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnEliminar.Click
        If Me.vista.CurrentPosition > -1 Then
            If MessageBox.Show("¿Está seguro de borrar este registro?", Me.Title, MessageBoxButton.YesNo) = MessageBoxResult.Yes Then
                'Establece la fila actual de la vista de datos (registro) a eliminar
                Dim filaBorrar = CType(Me.vista.CurrentItem, System.Data.DataRowView).Row
                'Borra la fila actual de la vista
                filaBorrar.Delete()
                If Me.ProveedoresDatos.HasChanges Then
                    'Actualiza los datos de la vista, eliminando la fila borrada de la misma
                    Me.taAdmin.UpdateAll(Me.ProveedoresDatos)
                    MsgBox("El registro fue eliminado!")
                End If
            End If
            'Llama al procedimiento EstadoBotones para que haga visible o invisible
            'los botones agregar, modificar o eliminar
            tipoCarga = 0
            EstadoBotones(1)
        End If
    End Sub

    Private Sub btnAgregar_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnAgregar.Click
        'Establece la fila por agregar en la vista y la incluye en la colección
        Dim filaAgregar = Me.ProveedoresDatos.tbProveedores.NewtbProveedoresRow
        Me.btnAceptar.Visibility = Windows.Visibility.Visible
        Me.btnCancelar.Visibility = Windows.Visibility.Visible
        'Llama al procedimiento EstadoBotones para que haga visible o invisible
        'los botones agregar, modificar o eliminar
        tipoCarga = 1
        EstadoBotones(2)
        'Habilita el foco en el objeto TextBox1
        Me.TextBox1.Focus()
        'En la coleccion filaAgregar establece los valores de cada columna
        filaAgregar.IdProveedor = ""
        filaAgregar.Nombre = ""
        filaAgregar.Apellidos = ""
        filaAgregar.Direccion = ""
        filaAgregar.Telefono = ""
        filaAgregar.IdPais = cmbPaises.SelectedValue
        'Agrega la fila al enlace de datos y actualiza la fuente de datos
        Me.ProveedoresDatos.tbProveedores.AddtbProveedoresRow(filaAgregar)
        'Se posiciona en el último registro de la vista
        Me.vista.MoveCurrentToLast()
    End Sub
    Sub PerderFoco(ByVal objeto As TextBox)
        'El objeto se configura con un fondo de color degradado cuando pierde el foco
        objeto.Background = New LinearGradientBrush(Colors.White, Colors.Snow, 90)
    End Sub
    Sub ObtenerFoco(ByVal objeto As TextBox)
        'El objeto se configura con un fondo de color degradado cunado se obtiene el foco
        objeto.Background = New LinearGradientBrush(Colors.LightBlue, Colors.Snow, 90)
    End Sub
    Private Sub TextBox1_GotFocus(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles TextBox1.GotFocus
        'Ejecuta ObtenerFoco cuando TextBox1 obtiene el foco
        ObtenerFoco(Me.TextBox1)
    End Sub

    Private Sub btnAceptar_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnAceptar.Click
        Try
            'Si hay cambios en la colección!
            If Me.ProveedoresDatos.HasChanges Then
                'Si hay actualizaciones!
                If Me.taAdmin.UpdateAll(Me.ProveedoresDatos) > 0 Then
                    MsgBox("Registro procesado!")
                    Me.btnAceptar.Visibility = Windows.Visibility.Hidden
                    Me.btnCancelar.Visibility = Windows.Visibility.Hidden
                    'Llama al procedimiento EstadoBotones para que haga visible o invisible
                    'los botones agregar, modificar o eliminar
                    EstadoBotones(1)
                    'tipoCarga = 0
                    CargarCmbPaises()
                End If
            End If
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub
    Sub EstadoBotones(ByVal Estado%)
        'Habilita o no la visibilidad de los botones de acuerdo al parámetro recibido
        'los botones agregar, modificar o eliminar
        If Estado = 1 Then
            Me.btnAgregar.Visibility = Windows.Visibility.Visible
            Me.btnEliminar.Visibility = Windows.Visibility.Visible
            Me.btnModificar.Visibility = Windows.Visibility.Visible
        Else
            Me.btnAgregar.Visibility = Windows.Visibility.Hidden
            Me.btnEliminar.Visibility = Windows.Visibility.Hidden
            Me.btnModificar.Visibility = Windows.Visibility.Hidden
        End If
    End Sub
    Private Sub btnCancelar_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnCancelar.Click
        If Me.ProveedoresDatos.HasChanges Then
            If MessageBox.Show("¿Está seguro de deshacer todos los cambios?", Me.Title, MessageBoxButton.YesNo) = MessageBoxResult.Yes Then
                'Cancela los cambios hechos en la colección de datos
                Me.ProveedoresDatos.RejectChanges()
                Me.btnAceptar.Visibility = Windows.Visibility.Hidden
                Me.btnCancelar.Visibility = Windows.Visibility.Hidden
                tipoCarga = 0
                CargarCmbPaises()
                EstadoBotones(1)
            End If
        End If
    End Sub
    Private Sub btnModificar_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnModificar.Click
        If Me.vista.CurrentPosition > -1 Then
            If MessageBox.Show("¿Está seguro de Modificar este registro?", Me.Title, MessageBoxButton.YesNo) = MessageBoxResult.Yes Then
                If Me.ProveedoresDatos.HasChanges Then
                    Me.taAdmin.UpdateAll(Me.ProveedoresDatos)
                    MsgBox("El registro fue actualizado!")
                End If
            End If
            tipoCarga = 0
            EstadoBotones(1)
        End If
    End Sub

    Private Sub TextBox1_LostFocus(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles TextBox1.LostFocus
        'llama al procedimiento PerderFoco cuando TextBox1 pierde el foco
        PerderFoco(TextBox1)
    End Sub

    Private Sub TextBox2_GotFocus(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles TextBox2.GotFocus
        'Ejecuta ObtenerFoco cuando TextBox2 obtiene el foco
        ObtenerFoco(TextBox2)
    End Sub

    Private Sub TextBox2_LostFocus(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles TextBox2.LostFocus
        PerderFoco(TextBox2)
    End Sub

    Private Sub TextBox3_GotFocus(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles TextBox3.GotFocus
        'Ejecuta ObtenerFoco cuando TextBox3 obtiene el foco
        ObtenerFoco(TextBox3)
    End Sub

    Private Sub TextBox3_LostFocus(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles TextBox3.LostFocus
        PerderFoco(TextBox3)
    End Sub

    Private Sub TextBox4_GotFocus(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles TextBox4.GotFocus
        'Ejecuta ObtenerFoco cuando TextBox4 obtiene el foco
        ObtenerFoco(TextBox4)
    End Sub

    Private Sub TextBox4_LostFocus(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles TextBox4.LostFocus
        PerderFoco(TextBox4)
    End Sub

    Private Sub TextBox5_GotFocus(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles TextBox5.GotFocus
        'Ejecuta ObtenerFoco cuando TextBox5 obtiene el foco
        ObtenerFoco(TextBox5)
    End Sub

    Private Sub TextBox5_LostFocus(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles TextBox5.LostFocus
        PerderFoco(TextBox5)
    End Sub


    Private Sub TextBox1_TextChanged(ByVal sender As System.Object, ByVal e As System.Windows.Controls.TextChangedEventArgs) Handles TextBox1.TextChanged
        'Carga el pais de origen del proveedor, según proveedor actual
        If tipoCarga = 0 Then CambiarCmbPaises()
    End Sub

    Sub CambiarCmbPaises()
        Dim datosProv = From p In db.tbProveedores _
                Where p.IdProveedor = Trim(TextBox1.Text) _
                  Select p.IdPais
        Dim cad As String = ""
        Dim IdProve As String = ""
        Dim pos = 0
        For Each cad In datosProv
            IdProve = cad
        Next
        For i = 0 To cmbPaises.Items.Count - 1
            Me.cmbPaises.SelectedIndex = i
            If Val(Me.cmbPaises.SelectedValue) = Val(IdProve) Then
                Exit For
            End If
        Next
    End Sub
End Class
